<template>
	<v-row class="search-box">
		<v-col v-if="label" :cols="labelCols">
			<label for="" class="search-box-label">
				<v-icon x-small color="primary" class="mr-1">mdi-record-circle</v-icon>
				{{ label }}
			</label>
		</v-col>
		<v-col :cols="label ? textCols : ''">
			<v-select
				v-if="loadSelectBox"
				v-model="selectValue"
				:items="searchParam[parentPrgmId].dtctCdList"
				item-text="commCdNm"
				item-value="idx"
				solo
				outlined
				:hide-details="true"
				append-icon="mdi-chevron-down"
				class="v-select__custom"
			></v-select>
		</v-col>
	</v-row>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
export default {
	props: {
		parentPrgmId: {
			type: String,
			require: true,
		},
		autoLoad: {
			type: Boolean,
			require: false,
			default: true,
		},
		label: {
			type: String,
			require: false,
			default: '감시 시스템',
		},
		addAll: {
			type: Boolean,
			require: false,
			default: false,
		},
		textCols: {
			type: Number,
			require: false,
			default: 7,
		},
		labelCols: {
			type: Number,
			require: false,
			default: 5,
		},
	},
	data() {
		return {
			loadSelectBox: false,
		};
	},
	computed: {
		...mapState({
			searchParam: state => state.pageData,
		}),
		selectValue: {
			get() {
				return this.searchParam[this.parentPrgmId].dtctCd;
			},
			set(value) {
				return this.setPageData({ dtctCd: value });
			},
		},
	},
	async created() {
		if (this.autoLoad) {
			await this.initData();
		}
	},
	methods: {
		...mapMutations({ setPageData: 'setPageData' }),
		...mapActions({
			postApi: 'modules/list/postApi',
			postUpdateApi: 'modules/list/postUpdateApi',
			postApiReturn: 'modules/list/postApiReturn',
			setTree: 'modules/list/setTree',
			chkOpenTabList: 'chkOpenTabList',
		}),
		async initData() {
			this.loadSelectBox = false;
			var dtctCdList = await this.postApiReturn({
				apiKey: 'selectCommCd',
				resKey: 'commCdData',
				sendParam: {
					commGrpCd: 'EM_SYS',
					useFg: '1',
				},
			});
			if (this.addAll) {
				dtctCdList.unshift({
					commCd: '',
					commCdNm: '전체',
				});
			}

			var tempIdx = 0;
			dtctCdList.map(item => {
				item.idx = tempIdx++;
			});

			this.setPageData({ dtctCd: 0, dtctCdList: dtctCdList });
			this.loadSelectBox = true;
		},
	},
};
</script>

<style></style>
